/*
 * parse.h
 */

struct param {
    int len;
    char *s;
};

void parse();
int brace_balance();
int parse_walk();
int min_match_len();
int search_action();
int escape_specials();
void escape_command();
void unescape();
void escape_seq();
void unescape_seq();
char *chop_arg();
char *chop_str();
char *skipspace();
char *skipnum();

#ifdef OWN_CTYPE
extern const unsigned char ct_array[256];
#undef isprint
#undef isgraph
#undef isalpha
#undef isdigit
#define C_TYPE(c) (ct_array[(unsigned char)(c)])
#define isgraph(c) (C_TYPE(c) & 0x01)
#define isprint(c) (C_TYPE(c) & 0x41)
#define isalpha(c) (C_TYPE(c) & 0x02)
#define isdigit(c) (C_TYPE(c) & 0x04)
#define islabel(c) (C_TYPE(c) & 0x0e)
#define isrparen(c) (C_TYPE(c) & 0x10)
#define islparen(c) (C_TYPE(c) & 0x20)
#else
#define islabel(c) (isalnum(c) || (c) == '_')
#define isrparen(c) ((c) == ')' || (c) == ']' || (c) == '}')
#define islparen(c) ((c) == '(' || (c) == '[' || (c) == '{')
#endif

/* the following two defines are also ASCII-dependant! */
#define ctoi(c) ((int)((unsigned char)(c) - '0'))
#define CONTROL(c) ((unsigned char)(c) & 0x1f)
#define LPAREN(c) ((c) == ')' ? '(' : ((c) == ']' ? '[' : '{'))
